#include <iostream>
#include <string>

using namespace std;

class Data {
public:
	Data(const std::string& t, const std::string& n, unsigned long s, unsigned long l) :
	    type(t), name(n), type_size(s), length(l) {};
	//virtual ~Data() {};
	inline std::string get_type(void) const { return type; };
	inline std::string get_name(void) const { return name; };
	inline unsigned long get_type_size(void) const { return type_size; };
	inline unsigned long get_len(void) const { return length; };
	inline unsigned long get_tot_size(void) const 
						{ return length * type_size; };
private:
	std::string type;
	std::string name;
	unsigned long type_size;
	unsigned long length;
};

class DataInt8 : public Data {
public:
	DataInt8(const std::string& name, unsigned long len) : 
	    Data("int8", name, 1, len)
	{
		cout << __PRETTY_FUNCTION__ << ": name=" << name << endl;
		actual_data = new char[len];

	};
	~DataInt8()
	{
		cout << __PRETTY_FUNCTION__ << ": name=" << get_name() << endl;
		delete[] actual_data;
	};
	
	char* actual_data;
};

Data* data_creator(/*could take params...*/)
{
	// might decide what Data has to be created
	//...
	return new DataInt8("test_data3", 5);
}

int main(void)
{
	{
	DataInt8 d1("test_data1", 1);
	DataInt8 d2("test_data2", 10);
	}
	// Note: d1,d2 destructor is called when scope terminates
	//       d3 has to be manually deleted
	Data* d3 = data_creator();

	delete d3;

	return 0;
}
